Subject: Re: [aqm] RED implementation on Linux 3.14.22

From: Simone Ferlin-Oliveira <[email-masked]>
Date: Mon, 5 Jan 2015 16:13:39 +0100

Hi Jim,
Hi Dave,

Thanks a lot for the pointers. Very helpful!
And happy new year too!

It took me some time to catch up here, sorry for that. From the
links/options you posted, it looks like there was no major change (bug
fix), only refactoring, since 2012:
https://github.com/torvalds/linux/commits/master/net/sched/sch_red.c

On 15 December 2014 at 17:17, Dave Taht <[email-masked]> wrote:
> On Mon, Dec 15, 2014 at 7:54 AM, Dave Taht <[email-masked]> wrote:
>> On Mon, Dec 15, 2014 at 5:41 AM, Jim Gettys <[email-masked]> wrote:
>>>
>>>
>>> On Mon, Dec 15, 2014 at 2:51 AM, Simone Ferlin-Oliveira <[email-masked]>
>>> wrote:
>>>>
>>>> All,
>>>>
>>>> I am doing some work with shared bottleneck detection that requires
>>>> some evaluation with different AQM, in particular, RED. Since I
>>>> haven't been following the evolution of the implementation,  I would
>>>> like to ask about your experience with the code on Linux 3.14 (and
>>>> newer).
>
> I need to clarify something about "newer". The third parameter in Linux is
> for bug fixes only. 3.14 is the major release, a 3.14.22 was 22 bug
> fix releases. A -X or 4th parameter, if it exists, is distro specific
> changes, which can often, particularly in major distros like redhat or
> ubuntu, be quite extensive.
>
> "New features", such as the ones I mentioned in the previous email, generally
> do not make it to the bug fix releases, and I don't know if (for
> example) the hystart
> change or GSO half cwnd change will make it to the -stable tree for
> older releases (without checking), as usually only security or crash
> critical bugs make it into stable.
>
> I mention this in light of a fairly recent DCTCP paper which used a
> pre-bufferbloat-fixes kernel of 3.2.something, discussed (Well, ranted
> about slightly, apologies) here.
>
> https://lists.bufferbloat.net/pipermail/bloat/2013-November/001736.html
>
> (I would dearly like to see that paper's experiments revised and
> updated in light of that discussion, now that all these other fixes
> have landed, and DCTCP is now in mainline linux.)
>
> I try to publish a simple debian kernel build script, and my own patch
> set of the codel-related research in progress regularly, somewhere:
>
> http://snapon.lab.bufferbloat.net/~d/codel_patches/
>
> and will probably restart publishing a separate debloat-testing tree
> for the upcoming make-wifi-fast effort, as that set of changes is
> going to be quite extensive, and buggy, for a while.
>
> --
> Dave Täht
>
> http://www.bufferbloat.net/projects/bloat/wiki/Upcoming_Talks